module Brighter3DSoftwareDevelopmentLtd
module Brighter3D

  @su_os = ((Object::RUBY_PLATFORM =~ /darwin/i) ? 'mac' : 'win')

  if Sketchup.version.to_i >= 17 then
    #if defined? Sketchup
      Sketchup.require 'fiddle'
    #else
     # require 'fiddle'
     # require 'Brighter3D/B3DConn'
    #end
  end

    # In SU2014, with Ruby 2.0 the __FILE__ constant return an UTF-8 string with
    # incorrect encoding label which will cause load errors when the file path
    # contain multi-byte characters. This happens when the user has non-english
    # characters in their username.
    current_path = File.dirname(__FILE__)
    if current_path.respond_to?(:force_encoding)
      current_path.force_encoding("UTF-8")
    end

    PLUGIN_PATH    = current_path.freeze
    B3D_PRO = true
    

  # setup
  @pathRoot = PLUGIN_PATH #Sketchup.find_support_file("Plugins/Brighter3D")
  @path=""

  if Sketchup.respond_to?(:is_64bit?) && Sketchup.is_64bit?
    # Load 64bit binaries.
    path64 = @pathRoot + "/x64/Debug"
    orgEnv = ENV['PATH']
    ENV['PATH'] = path64 +";"+ ENV['PATH']

      mydll = path64 + "/libBrighter20_NGUI.dylib"
  else
    # Load 32bit binaries.
	  UI.messagebox("Brighter3D requires 64 bit version of SketchUp!")    
  end
  

if (Sketchup.version.to_i >= 17) && (Sketchup.version.to_i <= 20) then
    libm = Fiddle.dlopen(mydll)
    BRtest = Fiddle::Function.new(libm['ShowDialog']            ,[Fiddle::TYPE_INT],Fiddle::TYPE_INT)
    BRquit = Fiddle::Function.new(libm['QuitDialog']            ,[Fiddle::TYPE_INT],Fiddle::TYPE_INT)
    
else
  UI.messagebox("Brighter3D requires 64bit SketchUp 2017, 2018 or 2019!")    
end

  ENV['PATH'] = orgEnv


  def Brighter3D.CallAboutWindow
       p "in brtest"
       BRtest.call(4)
       Sketchup.active_model.select_tool(nil)
       p "out brtest"
       #UI.refresh_inspectors
       #UI.refresh_toolbars
       p "out2"
  end

  def Brighter3D.CallQuitWindow
       p "in quit"
       BRquit.call(4)
       p "out quit7"
       UI.refresh_inspectors
       UI.refresh_toolbars
  end

  def Brighter3D.InitToolbar(path)
    ic1 = File.join(path,"icons/brighter3D_2.0_STDTHEME_toolbar_icon_render_24x24.png")
    ic2 = File.join(path,"icons/brighter3D_2.0_STDTHEME_toolbar_icon_settings_24x24.png")
    ic4 = File.join(path,"icons/brighter3D_2.0_STDTHEME_toolbar_icon_material_editor_24x24.png")

    ic1b = File.join(path,"icons/brighter3D_2.0_STDTHEME_toolbar_icon_render_48x48.png")
    ic2b = File.join(path,"icons/brighter3D_2.0_STDTHEME_toolbar_icon_settings_48x48.png")
    ic4b = File.join(path,"icons/brighter3D_2.0_STDTHEME_toolbar_icon_material_editor_48x48.png")

    toolb = UI::Toolbar.new("Brighter3D")

    tbutton1 = UI::Command.new("Render Scene"){ Brighter3D.CallAboutWindow      }
    tbutton1.tooltip = tbutton1.status_bar_text = "Brighter3D - render scene"
    tbutton1.small_icon = ic1
    tbutton1.large_icon = ic1b

    toolb.add_item(tbutton1)

    tbutton2 = UI::Command.new("Quit Scene"){ Brighter3D.CallQuitWindow      }
    tbutton2.tooltip = tbutton2.status_bar_text = "Brighter3D - quit scene"
    tbutton2.small_icon = ic2
    tbutton2.large_icon = ic2b

    toolb.add_item(tbutton2)
    toolb.show
  end

# init toolbar
Brighter3D.InitToolbar(@pathRoot)

end # module Brighter3D
end # module Brighter3DSoftwareDevelopmentLtd

#Brighter3DSoftwareDevelopmentLtd::Brighter3D.exportPBR